/***************************************************************************
 *   Copyright (C) 2004 by Michael Moritz                                  *
 *   mimo@restoel.net                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef __DBIQUOTE_H
#define __DBIQUOTE_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

//#include "db.h"
//#include "defs.h"
//#include <signal.h>
//#include <syslog.h>
//#include <iostream>
//#include <iomanip>
//#include "triplet.h"
//#include <sstream>
#include <string>
#include <stdexcept>
//#include "cfg.h"
//#include "tmplwlmod.h"
//#include "wldb.h"
//#include "wlcacheddb.h"
//#include "dbdefs.h"

using namespace std;
// define the wl modules
typedef TmplWlMod<WLDB> DbWlModule;
typedef TmplWlMod<WlCachedDB> CachedDbWlModule;

#ifdef OLD_DBI_VERSION 
#define DBI_CON_QUERYF dbi_conn_query
#warning "using old DBI dbi_driver_quote_string -> using workaround"
class DBIQuote
{
public:
	DBIQuote(dbi_driver drv,const std::string& str) throw (runtime_error)
	: _str("'"+str+"'")
        {
	}
	const char* operator() () { return _str.c_str(); }
private:
	string _str;
};
#else
#define DBI_CON_QUERYF dbi_conn_queryf
class DBIQuote
{
public:
	DBIQuote(dbi_driver drv,const std::string& str) throw (runtime_error)
	{
		_psz = (char*) malloc((str.length()+1)*sizeof(char));
		if(!_psz)
			throw runtime_error("malloc "+str);
		strcpy(_psz,str.c_str());
		dbi_driver_quote_string(drv,&_psz);
	//	std::cout << str << "->" << _psz <<std::endl;
	}
	const char* operator() () { return _psz; }
	~DBIQuote() 
	{
		if(_psz) { //always
			free(_psz);
			_psz = 0;
		}
	}
private:
	char *_psz;
};
#endif

#endif //__DBIQUOTE_H
